using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Bson.Serialization;
using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Inventory.Systems.VirtualMaschines;

[Route(Navigation.Inventory.Systems.VirtualMaschines.Index)]
public partial class Index
{
    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;

    private TableContainer<ViewModel>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override void OnInitialized()
    {
        Title = $"Inventory » Virtual Maschines｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Inventory", href: "#", true));
        Breadcrumbs.Add(new BreadcrumbItem("Virtual Maschines", href: "#", true));
    }

    private async Task<TableData<ViewModel>> LoadDataAsync(TableState state)
    {
        try
        {
            var search = Builders<BsonDocument>.Filter.Empty;

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                search &= Builders<BsonDocument>.Filter.Regex("host.name", regex) |
                    Builders<BsonDocument>.Filter.Regex("customer.name", regex) |
                    Builders<BsonDocument>.Filter.Regex("name", regex) |
                    Builders<BsonDocument>.Filter.Regex("version_configuration", regex) |
                    Builders<BsonDocument>.Filter.Regex("guest_os", regex) |
                    Builders<BsonDocument>.Filter.Regex("enabled", regex) |
                    Builders<BsonDocument>.Filter.Regex("health", regex);
            }

            var query = Database.HostHypervisorVirtualMaschine()
                .Aggregate()
                .Lookup("host", "_host", "_id", "hosts")
                .Match(new BsonDocument("hosts", new BsonDocument
                {
                    { "$exists", true },
                    { "$ne", new BsonArray() }
                }))
                .AppendStage<BsonDocument>(new BsonDocument("$addFields", new BsonDocument
                {
                    { "host", new BsonDocument("$first", "$hosts") }
                }))
                .Lookup("customer", "host._customer", "_id", "customers")
                .AppendStage<BsonDocument>(new BsonDocument("$addFields", new BsonDocument
                {
                    { "customer", new BsonDocument("$first", "$customers") }
                }))
                .Lookup("host_hv_vm_cfg", "_id", "virtualmaschine", "snapshots")
                .Project(new BsonDocument
                {
                    { "_id", 1 },
                    { "host", 1 },
                    { "customer", 1 },
                    { "name", 1 },
                    { "version_configuration", 1 },
                    { "guest_os", 1 },
                    { "enabled", 1 },
                    { "health", 1 },
                    { "snapshots_count", new BsonDocument("$subtract", new BsonArray
                        {
                            new BsonDocument("$size", "$snapshots"), 1
                        }) }
                })
                .Match(search)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Ascending("host.name"),
                        "Customer" => Builders<BsonDocument>.Sort.Ascending("customer.name"),
                        "Name" => Builders<BsonDocument>.Sort.Ascending("name"),
                        "Configuration" => Builders<BsonDocument>.Sort.Ascending("version_configuration"),
                        "GuestOs" => Builders<BsonDocument>.Sort.Ascending("guest_os"),
                        "Enabled" => Builders<BsonDocument>.Sort.Ascending("enabled"),
                        "Health" => Builders<BsonDocument>.Sort.Ascending("health"),
                        "Snapshots" => Builders<BsonDocument>.Sort.Ascending("snapshots_count"),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Descending("host.name"),
                        "Customer" => Builders<BsonDocument>.Sort.Descending("customer.name"),
                        "Name" => Builders<BsonDocument>.Sort.Descending("name"),
                        "Configuration" => Builders<BsonDocument>.Sort.Descending("version_configuration"),
                        "GuestOs" => Builders<BsonDocument>.Sort.Descending("guest_os"),
                        "Enabled" => Builders<BsonDocument>.Sort.Descending("enabled"),
                        "Health" => Builders<BsonDocument>.Sort.Descending("health"),
                        "Snapshots" => Builders<BsonDocument>.Sort.Descending("snapshots_count"),
                        _ => null
                    },
                    _ => Builders<BsonDocument>.Sort.Ascending("health")
                });

            var countResult = await query.Count().FirstOrDefaultAsync(default);
            var itemResult = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default);

            return new TableData<ViewModel>()
            {
                TotalItems = countResult is null ? 0 : (int)countResult.Count,
                Items = itemResult.Select(x => BsonSerializer.Deserialize<ViewModel>(x))
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<ViewModel>();
        }
    }

    [BsonIgnoreExtraElements]
    public class ViewModel
    {
        [BsonId]
        public ObjectId? Id { get; set; }

        [BsonElement("host")]
        public HostEntity? Hosts { get; set; }

        [BsonElement("customer")]
        public CustomerEntity? Customers { get; set; }

        [BsonElement("name")]
        public string? Name { get; set; }

        [BsonElement("version_configuration")]
        public string? Configuration { get; set; }

        [BsonElement("guest_os")]
        public string? GuestOs { get; set; }

        [BsonElement("enabled")]
        public string? Enabled { get; set; }

        [BsonElement("health")]
        public string? Health { get; set; }

        [BsonElement("snapshots_count")]
        public int? Snapshots { get; set; }
    }
}